function varargout = GPlan(varargin)
% GPLAN M-file for GPlan.fig
%      GPLAN, by itself, creates a new GPLAN or raises the existing
%      singleton*.
%
%      H = GPLAN returns the handle to a new GPLAN or the handle to
%      the existing singleton*.
%
%      GPLAN('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GPLAN.M with the given input arguments.
%
%      GPLAN('Property','Value',...) creates a new GPLAN or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before GPlan_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to GPlan_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Copyright 2002-2003 The MathWorks, Inc.

% Edit the above text to modify the response to help GPlan

% Last Modified by GUIDE v2.5 26-Mar-2006 13:46:09
% Written by A. McClung 04/13/05 - Stanford Univ.

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @GPlan_OpeningFcn, ...
                   'gui_OutputFcn',  @GPlan_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before GPlan is made visible.
function GPlan_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to GPlan (see VARARGIN)

% Choose default command line output for GPlan
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes GPlan wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = GPlan_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in Calc.
function Calc_Callback(hObject, eventdata, handles)
% hObject    handle to Calc (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%Turn off the animation button
set(handles.AnimBut,'Value',0);
%Draw the new body and legs
%Reset the plot formatting
newplot(handles.BodyPlot);
cla(handles.BodyPlot);
set(handles.BodyPlot,'XColor','w')
set(handles.BodyPlot,'YColor','w')
set(handles.BodyPlot,'XTickLabel','')
set(handles.BodyPlot,'YTickLabel','')
bodyWidth=0.4;
bodyLength=0.6;
legRadius=0.08;
legSpace=1.7;
numLegs=4;

% Get the GUI editable DC values
strokeDC = str2num(get(handles.StrokeDC, 'String'));
wingAboveDC = str2num(get(handles.WingAboveDC, 'String'));
wingBelowDC = str2num(get(handles.WingBelowDC, 'String'));
footDC = str2num(get(handles.FootDC, 'String'));
unloadDC = str2num(get(handles.UnloadDC, 'String'));
returnDC = str2num(get(handles.ReturnDC, 'String'));

% get the starting phases
phase(1) = str2num(get(handles.Leg0PhaseOffset, 'String'));
phase(2) = str2num(get(handles.Leg1PhaseOffset, 'String'));
phase(3) = str2num(get(handles.Leg2PhaseOffset, 'String'));
phase(4) = str2num(get(handles.Leg3PhaseOffset, 'String'));

if (returnDC <= 0)
    disp('Return Stroke DC is zero or less.  Please alter the other DC values until there is a positive Return Stroke DC');
    return;
end

%Plot the body
hold(handles.BodyPlot,'on');
plot(handles.BodyPlot,[-bodyWidth/2 bodyWidth/2 bodyWidth/2 -bodyWidth/2 -bodyWidth/2 ],...
    [-bodyLength/2 -bodyLength/2 bodyLength/2 bodyLength/2 -bodyLength/2],'k')
%Plot the legs (legs must be in pairs, ie. even #)
for i=1:numLegs/2
    xpos=bodyWidth*legSpace/2;
    ypos=bodyLength/2-bodyLength*((i-1)/(numLegs/2-1));
    circle5(xpos,ypos,legRadius,[0 0 1],handles.BodyPlot);
    circle5(-xpos,ypos,legRadius,[0 0 1],handles.BodyPlot);
    h=text(xpos*1.5,ypos,[num2str(numLegs-i)]);
    set(h,'Parent',handles.BodyPlot);  %Hack to get labels in right window
    h=text(-xpos*1.6,ypos,[num2str(i-1)]);
    set(h,'Parent',handles.BodyPlot);
end
set(handles.BodyPlot,'XLim',[-1,1])
set(handles.BodyPlot,'YLim',[-1,1])
%Draw the new leg temporal maps
newplot(handles.LegTimePlot);
cla(handles.LegTimePlot);
set(handles.LegTimePlot,'XGrid','on');
set(handles.LegTimePlot,'YTickLabel','')
hold(handles.LegTimePlot,'on');
tempSpace=1/(numLegs+1);
c='rgbcmywk';
ylabelpos=0;
ylabeltext='';
%Plot the top and bottom limits on temporal display and fill in w/colors
for i=1:numLegs
    bot=i*tempSpace/(numLegs+1)+(i-1)*tempSpace;
    top=i*tempSpace/(numLegs+1)+i*tempSpace;
    plot(handles.LegTimePlot,[0 1],[bot bot],'k');
    plot(handles.LegTimePlot,[0 1],[top top],'k');
    templeg=fill([0 1 1 0],[bot bot top top],[.67 .67 .67]);
    set(templeg,'FaceAlpha',.2);
    
    % Add Graphics for Stroke
    start = mod(phase(i), 1);
    stop = mod(start + strokeDC, 1);
    if (start <= stop)
        h = fill([start stop stop start],[bot bot top top],c(3));
        set(h,'FaceAlpha',.5);
    else
        h = fill([1 start start 1],[bot bot top top],c(3));
        set(h,'FaceAlpha',.5);
        h = fill([0 stop stop 0],[bot bot top top],c(3));
        set(h,'FaceAlpha',.5);
    end
    
    %Add graphics for Unloading
    if (footDC < unloadDC)
        start = mod(stop, 1);
        stop = mod(start + unloadDC - footDC, 1);
        if (start <= stop)
            h = fill([start stop stop start],[bot bot top top],c(5));
            set(h,'FaceAlpha',.5);
        else
            h = fill([1 start start 1],[bot bot top top],c(5));
            set(h,'FaceAlpha',.5);
            h = fill([0 stop stop 0],[bot bot top top],c(5));
            set(h,'FaceAlpha',.5);
        end
    end
    
    % Add graphics for foot detachment
    start = mod(stop, 1);
    stop = mod(start + min(footDC, unloadDC), 1);
    if (start <= stop)
        h = fill([start stop stop start],[bot bot top top],c(1));
        set(h,'FaceAlpha',.5);
    else
        h = fill([1 start start 1],[bot bot top top],c(1));
        set(h,'FaceAlpha',.5);
        h = fill([0 stop stop 0],[bot bot top top],c(1));
        set(h,'FaceAlpha',.5);
    end
    
    % Add graphics for wing up
    start = mod(stop, 1);
    stop = mod(start + wingAboveDC, 1);
    if (start <= stop)
        h = fill([start stop stop start],[bot bot top top],c(1));
        set(h,'FaceAlpha',.5);
    else
        h = fill([1 start start 1],[bot bot top top],c(1));
        set(h,'FaceAlpha',.5);
        h = fill([0 stop stop 0],[bot bot top top],c(1));
        set(h,'FaceAlpha',.5);
    end
    
    % Add graphics for wing down
    start = mod(stop + returnDC, 1);
    stop = mod(start + wingAboveDC, 1);
    if (start <= stop)
        h = fill([start stop stop start], [bot bot top top], c(2));
        set(h, 'FaceAlpha', .5);
    else
        h = fill([1 start start 1], [bot bot top top], c(2));
        set(h, 'FaceAlpha', .5);
        h = fill([0 stop stop 0], [bot bot top top], c(2));
        set(h, 'FaceAlpha', .5);
    end
    %% Old version
    %start = stop + returnDC;
    %stop = start + wingAboveDC;
    %h = fill([start stop stop start],[bot bot top top],c(2));
    %set(h,'FaceAlpha',.5);
    %if start < 0
    %    start = mod(start,1);
    %    h = fill([1 start start 1],[bot bot top top],c(2));
    %    set(h,'FaceAlpha',.5);
    %end
    %if stop > 1
    %    stop = mod(stop,1);
    %    h = fill([0 stop stop 0],[bot bot top top],c(2));
    %    set(h,'FaceAlpha',.5);
    %end
    
    % Add graphics for wing engaging
    start = mod(stop, 1);
    stop = mod(start + wingBelowDC, 1);
    if (start <= stop)
        h = fill([start stop stop start],[bot bot top top],c(2));
        set(h,'FaceAlpha',.5);
    else
        h = fill([1 start start 1],[bot bot top top],c(2));
        set(h,'FaceAlpha',.5);
        h = fill([0 stop stop 0],[bot bot top top],c(2));
        set(h,'FaceAlpha',.5);
    end
    
    % Add graphics for foot engaging
    start = mod(stop, 1);
    stop = mod(start + footDC, 1);
    if (start <= stop)
        h = fill([start stop stop start],[bot bot top top],c(2));
        set(h,'FaceAlpha',.5);
    else
        h = fill([1 start start 1],[bot bot top top],c(2));
        set(h,'FaceAlpha',.5);
        h = fill([0 stop stop 0],[bot bot top top],c(2));
        set(h,'FaceAlpha',.5);
    end
    
    % Add graphics for loading
    start = mod(stop, 1);
    stop = mod(start + wingBelowDC, 1);
    if (start <= stop)
        h = fill([start stop stop start],[bot bot top top],c(4));
        set(h,'FaceAlpha',.5);
    else
        h = fill([1 start start 1],[bot bot top top],c(4));
        set(h,'FaceAlpha',.5);
        h = fill([0 stop stop 0],[bot bot top top],c(4));
        set(h,'FaceAlpha',.5);
    end
    
    ylabelpos(i)=bot+tempSpace/2;
    ylabeltext=[ylabeltext; 'Leg #' num2str(i-1)];
end
set(handles.LegTimePlot,'XLim',[0,1])
set(handles.LegTimePlot,'YLim',[0,1])
set(handles.LegTimePlot,'YTick',ylabelpos)
set(handles.LegTimePlot,'YTickLabel',ylabeltext)


% --- Executes on button press in AnimBut.
function AnimBut_Callback(hObject, eventdata, handles)
% hObject    handle to AnimBut (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of AnimBut
speedConstant=25;
curtime=0;
timeBar=plot(handles.LegTimePlot,[0 0],[0 1],'k');
set(timeBar,'LineWidth',2);
speed=get(handles.PeriodSlider,'Value');
%Same basic constants as above
bodyWidth=0.4;
bodyLength=0.6;
legRadius=0.08;
legSpace=1.7;
numLegs=4;
tempSpace=1/(numLegs+1);

%Draw the legs for animation
for i=1:numLegs/2
    xpos=bodyWidth*legSpace/2;
    ypos=bodyLength/2-bodyLength*((i-1)/(numLegs/2-1));
    Leg(numLegs+1-i)=circle5(xpos,ypos,legRadius,[0 0 1],handles.BodyPlot);
    Leg(i)=circle5(-xpos,ypos,legRadius,[0 0 1],handles.BodyPlot);
end

% Get the color map to use for animating the feet,
f = getframe(handles.LegTimePlot);
height = size(f.cdata,1);
width = size(f.cdata,2);
colormap = f.cdata(round(height/8*[7 5 3 1]), :, :);

%Animate the plots
while get(hObject,'Value')==1
    speed=get(handles.PeriodSlider,'Value');
    curtime=mod(curtime+speed/speedConstant,1);
    set(timeBar,'XData',[curtime curtime]);
    for i=1:numLegs
        % Make the leg the same color as in the time plot
        color = double(colormap(i, round(curtime*width)+1, :))/255;
        color = reshape(color, 1, 3, 1);
        set(Leg(i), 'Color', color);
    end
    pause(0.1);
end
%Clean up animation stuff
if ishandle(timeBar)  %If these have not been cleared, clear them
    delete(timeBar);
    for i=1:numLegs
        delete(Leg(i));
    end
end



%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%



% --- Executes on slider movement.
function PeriodSlider_Callback(hObject, eventdata, handles)
% hObject    handle to PeriodSlider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

periodBounds=[2 20];  %Bounds for the slider (in secs)
periodslide=1-get(handles.PeriodSlider,'Value');
%set(handles.Period,'String',num2str(periodBounds(1)+periodslide*diff(periodBounds)),'%1.2f');
set(handles.Period,'String',num2str(periodBounds(1)+periodslide*diff(periodBounds),'%1.2f'));
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function PeriodSlider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to PeriodSlider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


function Period_Callback(hObject, eventdata, handles)
% hObject    handle to Period (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Period as text
%        str2double(get(hObject,'String')) returns contents of Period as a double

periodBounds=[2 20];  %Bounds for the slider (in secs)
period=str2num(get(handles.Period,'String'));
if period<periodBounds(1)
    period=periodBounds(1);
end
if period>periodBounds(2)
    period=periodBounds(2);
end
set(handles.PeriodSlider,'Value',1-((period-periodBounds(1))/diff(periodBounds)));
set(handles.Period,'String',num2str(period,'%1.2f'));
% Update handles structure
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function Period_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Period (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function StrokeDC_Callback(hObject, eventdata, handles)
% hObject    handle to ReturnDC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ReturnDC as text
%        str2double(get(hObject,'String')) returns contents of ReturnDC as a double

DC=str2num(get(handles.StrokeDC,'String'));
if DC>=1
    DC=0;
    set(handles.StrokeDC,'String','0.00');
end

% Change the return ReturnDC value
UpdateReturnDC(handles);

% Update handles structure
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function StrokeDC_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ReturnDC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function WingBelowDC_Callback(hObject, eventdata, handles)
% hObject    handle to DetDC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of DetDC as text
%        str2double(get(hObject,'String')) returns contents of DetDC as a double

DC=str2num(get(handles.WingBelowDC,'String'));
if DC>=1
    DC=0;
    set(handles.WingBelowDC,'String','0.00');
end

% Update Return DC
UpdateReturnDC(handles);

% Update handles structure
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function WingBelowDC_CreateFcn(hObject, eventdata, handles)
% hObject    handle to DetDC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function WingAboveDC_Callback(hObject, eventdata, handles)
% hObject    handle to AttDC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of AttDC as text
%        str2double(get(hObject,'String')) returns contents of AttDC as a double

DC=str2num(get(handles.WingAboveDC,'String'));
if DC>=1
    DC=0;
    set(handles.WingAboveDC,'String','0.00');
end

% Update Return DC
UpdateReturnDC(handles);

% Update handles structure
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function WingAboveDC_CreateFcn(hObject, eventdata, handles)
% hObject    handle to AttDC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%




function Leg0PhaseOffset_Callback(hObject, eventdata, handles)
% hObject    handle to Leg0PhaseOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Leg0PhaseOffset as text
%        str2double(get(hObject,'String')) returns contents of Leg0PhaseOffset as a double

legphase(1)=str2num(get(handles.Leg0PhaseOffset,'String'));
if legphase(1)>=1
    legphase(1)=0;
    set(handles.Leg0PhaseOffset,'String','0.00');
end
% Update handles structure
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function Leg0PhaseOffset_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Leg0PhaseOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function Leg1PhaseOffset_Callback(hObject, eventdata, handles)
% hObject    handle to Leg1PhaseOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Leg1PhaseOffset as text
%        str2double(get(hObject,'String')) returns contents of Leg1PhaseOffset as a double

legphase(2)=str2num(get(handles.Leg1PhaseOffset,'String'));
if legphase(2)>=1
    legphase(2)=0;
    set(handles.Leg1PhaseOffset,'String','0.00');
end
% Update handles structure
guidata(hObject, handles);



% --- Executes during object creation, after setting all properties.
function Leg1PhaseOffset_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Leg1PhaseOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function Leg2PhaseOffset_Callback(hObject, eventdata, handles)
% hObject    handle to Leg2PhaseOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Leg2PhaseOffset as text
%        str2double(get(hObject,'String')) returns contents of Leg2PhaseOffset as a double

legphase(3)=str2num(get(handles.Leg2PhaseOffset,'String'));
if legphase(3)>=1
    legphase(3)=0;
    set(handles.Leg2PhaseOffset,'String','0.00');
end
% Update handles structure
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function Leg2PhaseOffset_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Leg2PhaseOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function Leg3PhaseOffset_Callback(hObject, eventdata, handles)
% hObject    handle to Leg3PhaseOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Leg3PhaseOffset as text
%        str2double(get(hObject,'String')) returns contents of Leg3PhaseOffset as a double

legphase(4)=str2num(get(handles.Leg3PhaseOffset,'String'));
if legphase(4)>=1
    legphase(4)=0;
    set(handles.Leg3PhaseOffset,'String','0.00');
end
% Update handles structure
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function Leg3PhaseOffset_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Leg3PhaseOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%





function StrokeStart0_Callback(hObject, eventdata, handles)
% hObject    handle to StrokeStart0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of StrokeStart0 as text
%        str2double(get(hObject,'String')) returns contents of StrokeStart0 as a double


% --- Executes during object creation, after setting all properties.
function StrokeStart0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to StrokeStart0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function StrokeStart1_Callback(hObject, eventdata, handles)
% hObject    handle to StrokeStart1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of StrokeStart1 as text
%        str2double(get(hObject,'String')) returns contents of StrokeStart1 as a double


% --- Executes during object creation, after setting all properties.
function StrokeStart1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to StrokeStart1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function StrokeStart2_Callback(hObject, eventdata, handles)
% hObject    handle to StrokeStart2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of StrokeStart2 as text
%        str2double(get(hObject,'String')) returns contents of StrokeStart2 as a double


% --- Executes during object creation, after setting all properties.
function StrokeStart2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to StrokeStart2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function StrokeStart3_Callback(hObject, eventdata, handles)
% hObject    handle to StrokeStart3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of StrokeStart3 as text
%        str2double(get(hObject,'String')) returns contents of StrokeStart3 as a double


% --- Executes during object creation, after setting all properties.
function StrokeStart3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to StrokeStart3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function StrokeLoad3_Callback(hObject, eventdata, handles)
% hObject    handle to StrokeLoad3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of StrokeLoad3 as text
%        str2double(get(hObject,'String')) returns contents of StrokeLoad3 as a double


% --- Executes during object creation, after setting all properties.
function StrokeLoad3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to StrokeLoad3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function StrokeLoad2_Callback(hObject, eventdata, handles)
% hObject    handle to StrokeLoad2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of StrokeLoad2 as text
%        str2double(get(hObject,'String')) returns contents of StrokeLoad2 as a double


% --- Executes during object creation, after setting all properties.
function StrokeLoad2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to StrokeLoad2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function StrokeLoad1_Callback(hObject, eventdata, handles)
% hObject    handle to StrokeLoad1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of StrokeLoad1 as text
%        str2double(get(hObject,'String')) returns contents of StrokeLoad1 as a double


% --- Executes during object creation, after setting all properties.
function StrokeLoad1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to StrokeLoad1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function StrokeLoad0_Callback(hObject, eventdata, handles)
% hObject    handle to StrokeLoad0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of StrokeLoad0 as text
%        str2double(get(hObject,'String')) returns contents of StrokeLoad0 as a double


% --- Executes during object creation, after setting all properties.
function StrokeLoad0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to StrokeLoad0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%




function WingDown3_Callback(hObject, eventdata, handles)
% hObject    handle to WingDown3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of WingDown3 as text
%        str2double(get(hObject,'String')) returns contents of WingDown3 as a double


% --- Executes during object creation, after setting all properties.
function WingDown3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to WingDown3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function WingDown2_Callback(hObject, eventdata, handles)
% hObject    handle to WingDown2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of WingDown2 as text
%        str2double(get(hObject,'String')) returns contents of WingDown2 as a double


% --- Executes during object creation, after setting all properties.
function WingDown2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to WingDown2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function WingDown1_Callback(hObject, eventdata, handles)
% hObject    handle to WingDown1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of WingDown1 as text
%        str2double(get(hObject,'String')) returns contents of WingDown1 as a double


% --- Executes during object creation, after setting all properties.
function WingDown1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to WingDown1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function WingDown0_Callback(hObject, eventdata, handles)
% hObject    handle to WingDown0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of WingDown0 as text
%        str2double(get(hObject,'String')) returns contents of WingDown0 as a double


% --- Executes during object creation, after setting all properties.
function WingDown0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to WingDown0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function WingNom3_Callback(hObject, eventdata, handles)
% hObject    handle to WingNom3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of WingNom3 as text
%        str2double(get(hObject,'String')) returns contents of WingNom3 as a double


% --- Executes during object creation, after setting all properties.
function WingNom3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to WingNom3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function WingNom2_Callback(hObject, eventdata, handles)
% hObject    handle to WingNom2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of WingNom2 as text
%        str2double(get(hObject,'String')) returns contents of WingNom2 as a double


% --- Executes during object creation, after setting all properties.
function WingNom2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to WingNom2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function WingNom1_Callback(hObject, eventdata, handles)
% hObject    handle to WingNom1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of WingNom1 as text
%        str2double(get(hObject,'String')) returns contents of WingNom1 as a double


% --- Executes during object creation, after setting all properties.
function WingNom1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to WingNom1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function WingNom0_Callback(hObject, eventdata, handles)
% hObject    handle to WingNom0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of WingNom0 as text
%        str2double(get(hObject,'String')) returns contents of WingNom0 as a double


% --- Executes during object creation, after setting all properties.
function WingNom0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to WingNom0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function WingUp3_Callback(hObject, eventdata, handles)
% hObject    handle to WingUp3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of WingUp3 as text
%        str2double(get(hObject,'String')) returns contents of WingUp3 as a double


% --- Executes during object creation, after setting all properties.
function WingUp3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to WingUp3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function WingUp2_Callback(hObject, eventdata, handles)
% hObject    handle to WingUp2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of WingUp2 as text
%        str2double(get(hObject,'String')) returns contents of WingUp2 as a double


% --- Executes during object creation, after setting all properties.
function WingUp2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to WingUp2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function WingUp1_Callback(hObject, eventdata, handles)
% hObject    handle to WingUp1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of WingUp1 as text
%        str2double(get(hObject,'String')) returns contents of WingUp1 as a double


% --- Executes during object creation, after setting all properties.
function WingUp1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to WingUp1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function WingUp0_Callback(hObject, eventdata, handles)
% hObject    handle to WingUp0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of WingUp0 as text
%        str2double(get(hObject,'String')) returns contents of WingUp0 as a double


% --- Executes during object creation, after setting all properties.
function WingUp0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to WingUp0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%



% --- Executes on button press in WriteDAT2.
function WriteDAT2_Callback(hObject, eventdata, handles)
% hObject    handle to WriteDAT2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if (str2num(get(handles.ReturnDC, 'String')) <= 0)
    disp('Return Stroke DC is zero or less.  Please alter the other DC values until there is a positive Return Stroke DC');
    return;
end

servtab=CreateGaitTable(handles, 2);%Get the table of servo positions
N=size(servtab,1);                  %Number of sequence steps
W=size(servtab,2);                  %Number of columns

%Write the file
[nfile, pfile]=uiputfile('*.dat','Save As');
if length(nfile)<=3
    nfile=[nfile '.dat'];
else if strcmp(nfile(length(nfile)-3:length(nfile)),'.dat')~=1
        nfile=[nfile '.dat'];
    end
end
eval(['fid=fopen(''' nfile ''',''w'');'])
%Add the data for all the servos
for i=1:N
    %Write each column of data
    for j=1:W-1
        fprintf(fid,'%d\t',servtab(i,j));
    end
    %Add the step duration info
    fprintf(fid,'%d\t\r',servtab(i,W));
end
fclose(fid);


% --- Executes on button press in WriteDAT3.
function WriteDAT3_Callback(hObject, eventdata, handles)
% hObject    handle to WriteDAT3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

servtab=CreateGaitTable(handles, 3);%Get the table of servo positions
N=size(servtab,1);                  %Number of sequence steps
W=size(servtab,2);                  %Number of columns

%Write the file
[nfile, pfile]=uiputfile('*.dat','Save As');
if length(nfile)<=3
    nfile=[nfile '.dat'];
else if strcmp(nfile(length(nfile)-3:length(nfile)),'.dat')~=1
        nfile=[nfile '.dat'];
    end
end
eval(['fid=fopen(''' nfile ''',''w'');'])

%Enter the proper formatting for ver3 servo controller software to read
fprintf(fid,'Index\r');
fprintf(fid,' %d\r',N);
for i=1:15
    fprintf(fid,' 0\r');
end
fprintf(fid,'Sequence 0\r');

%Add the data for all the servos
for i=1:N
    for j=1:W-1
        fprintf(fid,'%d\t',servtab(i,j));
    end
    %Add the step duration info
    fprintf(fid,'%d\t\r',servtab(i,W));
end

%Enter the proper formatting for ver3 servo controller software to read
for i=1:15
    fprintf(fid,'Sequence %d\r',i);
end
fclose(fid);

%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%



% CREATEGAITTABLE will create a table of the servo positions that 
%  correspond to the user defined gait
function dataout=CreateGaitTable(handles, version)

% Get the GUI editable DC and position values
strokeDC = str2num(get(handles.StrokeDC, 'String'));
wingAboveDC = str2num(get(handles.WingAboveDC, 'String'));
wingBelowDC = str2num(get(handles.WingBelowDC, 'String'));
footDC = str2num(get(handles.FootDC, 'String'));
unloadDC = str2num(get(handles.UnloadDC, 'String'));
returnDC = str2num(get(handles.ReturnDC, 'String'));

phase(1) = str2num(get(handles.Leg0PhaseOffset, 'String'));
phase(2) = str2num(get(handles.Leg1PhaseOffset, 'String'));
phase(3) = str2num(get(handles.Leg2PhaseOffset, 'String'));
phase(4) = str2num(get(handles.Leg3PhaseOffset, 'String'));

strokeStart(1) = str2num(get(handles.StrokeStart0, 'String'));
strokeStart(2) = str2num(get(handles.StrokeStart1, 'String'));
strokeStart(3) = str2num(get(handles.StrokeStart2, 'String'));
strokeStart(4) = str2num(get(handles.StrokeStart3, 'String'));

strokeLoad(1) = str2num(get(handles.StrokeLoad0, 'String'));
strokeLoad(2) = str2num(get(handles.StrokeLoad1, 'String'));
strokeLoad(3) = str2num(get(handles.StrokeLoad2, 'String'));
strokeLoad(4) = str2num(get(handles.StrokeLoad3, 'String'));

strokeEnd(1) = str2num(get(handles.StrokeEnd0, 'String'));
strokeEnd(2) = str2num(get(handles.StrokeEnd1, 'String'));
strokeEnd(3) = str2num(get(handles.StrokeEnd2, 'String'));
strokeEnd(4) = str2num(get(handles.StrokeEnd3, 'String'));

wingDown(1) = str2num(get(handles.WingDown0, 'String'));
wingDown(2) = str2num(get(handles.WingDown1, 'String'));
wingDown(3) = str2num(get(handles.WingDown2, 'String'));
wingDown(4) = str2num(get(handles.WingDown3, 'String'));

wingNom(1) = str2num(get(handles.WingNom0, 'String'));
wingNom(2) = str2num(get(handles.WingNom1, 'String'));
wingNom(3) = str2num(get(handles.WingNom2, 'String'));
wingNom(4) = str2num(get(handles.WingNom3, 'String'));

wingUp(1) = str2num(get(handles.WingUp0, 'String'));
wingUp(2) = str2num(get(handles.WingUp1, 'String'));
wingUp(3) = str2num(get(handles.WingUp2, 'String'));
wingUp(4) = str2num(get(handles.WingUp3, 'String'));

footDown(1) = str2num(get(handles.FootDown0, 'String'));
footDown(2) = str2num(get(handles.FootDown1, 'String'));
footDown(3) = str2num(get(handles.FootDown2, 'String'));
footDown(4) = str2num(get(handles.FootDown3, 'String'));

footUp(1) = str2num(get(handles.FootUp0, 'String'));
footUp(2) = str2num(get(handles.FootUp1, 'String'));
footUp(3) = str2num(get(handles.FootUp2, 'String'));
footUp(4) = str2num(get(handles.FootUp3, 'String'));

period = str2num(get(handles.Period, 'String'));

%Calculate some useful variables
numLegs=4;
f=50;           %NOTE: Had to change? to 50Hz to work w/VM servo controller
N=f*period;     % Number of steps in the sequence (limited to 256 for ver3)
stepdur=1/f*1000;
%NOTE: The sequences can only be up to 256 frames for v3, 1024 for v2
if (version == 2)
    if (N > 1024)       
        stepdur=(period/1024);
        N=1024
    end
elseif (N > 256)  % Put everything else down to 256, to be safe.
    stepdur = (period/256);
    N = 256;
end

% Calcuate the time sequences.
strokeTime = [0; strokeDC; unloadDC + wingAboveDC; returnDC; wingAboveDC + wingBelowDC + footDC; wingBelowDC];
wingTime = [0; strokeDC + unloadDC; wingAboveDC; returnDC; wingAboveDC; wingBelowDC; footDC; wingBelowDC];
footTime = [0; strokeDC + unloadDC - footDC; footDC; 2*wingAboveDC + returnDC + wingBelowDC; footDC; wingBelowDC];

strokePnts = size(strokeTime,1);
wingPnts = size(wingTime,1);
footPnts = size(footTime,1);

for i = 2:strokePnts
    strokeTime(i) = sum(strokeTime(i-1:i));
end
for i = 2:wingPnts
    wingTime(i) = sum(wingTime(i-1:i));
end
for i = 2:footPnts
    footTime(i) = sum(footTime(i-1:i));
end

% Calculate the servo value sequences 
for i = 1:numLegs
    strokeVals(i,:) = [strokeLoad(i) strokeEnd(i) strokeEnd(i) strokeStart(i) strokeStart(i) strokeLoad(i)];
    wingVals(i,:) = [wingNom(i) wingNom(i) wingUp(i) wingUp(i) wingNom(i) wingDown(i) wingDown(i) wingNom(i)];
    footVals(i,:) = [footDown(i) footDown(i) footUp(i) footUp(i) footDown(i) footDown(i)];
    
end

% Calculate the interpolated servo positions
for i = 0:N-1
    currTime = i/N;
    %% NOTE: Currently this assumes servos are numbered sequentially for
    %% each leg (ie. S0=leg 0 wing, S1=leg 0 stroke, S2=leg 0 foot
    %% actuation)
    for j = 1:numLegs
        phaseTime = mod(currTime-phase(j), 1);
        
        % Wing angles:  find which interval we are currently in.
        index = max(find(wingTime <= phaseTime));
        
        % Interpolate within that interval
        servtab(i+1,3*j-2) = ((phaseTime - wingTime(index))*wingVals(j,index+1)...
            + (wingTime(index+1) - phaseTime)*wingVals(j,index))...
            /(wingTime(index+1) - wingTime(index));
        servtab(i+1,3*j-2) = round(servtab(i+1,3*j-2));
        
        % Stroke angles: find which interval we're currently in.
        index = max(find(strokeTime <= phaseTime));
        
        % Interpolate within that interval
        servtab(i+1,3*j-1) = ((phaseTime - strokeTime(index))*strokeVals(j,index+1)...
            + (strokeTime(index+1) - phaseTime)*strokeVals(j,index))...
            /(strokeTime(index+1) - strokeTime(index));
        servtab(i+1,3*j-1) = round(servtab(i+1,3*j-1));
        
        % Foot angles: find which interval we're currently in.
        index = max(find(footTime <= phaseTime));
        
        %Interpolate within that interval
        servtab(i+1,3*j) = ((phaseTime - footTime(index))*footVals(j,index+1)...
            + (footTime(index+1) - phaseTime)*footVals(j,index))...
            /(footTime(index+1) - footTime(index));
        servtab(i+1,3*j) = round(servtab(i+1,3*j));
    end
    
    % Add the time step
    servtab(i+1, 3*j+1) = stepdur;
end

% Put the columns in the correct sequence, depending on servo connections
dataout=ServoTrans(servtab);
%dataout=servtab;  %For Debugging



% SERVOTRANS will transform a servo sequence table to a form that matches
% the current wiring of Spinybot.  This is basically a column swapper.
% NOTE: The legs are numbered counterclockwise (starting with 0) from the
% top left.  This is similar to the RiSE leg numbering.
% Example:    
%                    ************   
%            Leg 0   *          *   Leg 3
%                    *          *
%                    *          *
%                    *          *
%                    *          *
%                    *          *
%            Leg 1   *          *   Leg 2
%                    ************

function dataout=ServoTrans(datain)

%Legs are determined by columns of the following variables, ie. [0 1 2 3]
%  and the numbers are the servos numbered by the servo controller
%  software/hardware/firmware (#0-11)
%(Based on 03/15/06 StickyBot setup -TM)
WingServ=[9 6 3 0]+1;          %Add 1 to work w/Matlab matrices
StrokeServ=[11 8 5 2]+1;       %Add 1 to work w/Matlab matrices
FootServ=[1 4 7 10]+1;         %Add 1 to work w/Matlab matrices
numLegs=4;

%Build a new table of servo data
for i=1:numLegs
    dataout(:,WingServ(i))=datain(:,(i-1)*3+1);
    dataout(:,StrokeServ(i))=datain(:,(i-1)*3+2);
    dataout(:,FootServ(i))=datain(:,(i-1)*3+3);
end
%Add the step durations
dataout(:,13)=datain(:,13);

function StrokeEnd3_Callback(hObject, eventdata, handles)
% hObject    handle to StrokeEnd3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of StrokeEnd3 as text
%        str2double(get(hObject,'String')) returns contents of StrokeEnd3 as a double


% --- Executes during object creation, after setting all properties.
function StrokeEnd3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to StrokeEnd3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function StrokeEnd2_Callback(hObject, eventdata, handles)
% hObject    handle to StrokeEnd2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of StrokeEnd2 as text
%        str2double(get(hObject,'String')) returns contents of StrokeEnd2 as a double


% --- Executes during object creation, after setting all properties.
function StrokeEnd2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to StrokeEnd2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function StrokeEnd1_Callback(hObject, eventdata, handles)
% hObject    handle to StrokeEnd1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of StrokeEnd1 as text
%        str2double(get(hObject,'String')) returns contents of StrokeEnd1 as a double


% --- Executes during object creation, after setting all properties.
function StrokeEnd1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to StrokeEnd1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function StrokeEnd0_Callback(hObject, eventdata, handles)
% hObject    handle to StrokeEnd0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of StrokeEnd0 as text
%        str2double(get(hObject,'String')) returns contents of StrokeEnd0 as a double


% --- Executes during object creation, after setting all properties.
function StrokeEnd0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to StrokeEnd0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function FootUp3_Callback(hObject, eventdata, handles)
% hObject    handle to FootUp3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of FootUp3 as text
%        str2double(get(hObject,'String')) returns contents of FootUp3 as a double


% --- Executes during object creation, after setting all properties.
function FootUp3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to FootUp3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function FootUp2_Callback(hObject, eventdata, handles)
% hObject    handle to FootUp2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of FootUp2 as text
%        str2double(get(hObject,'String')) returns contents of FootUp2 as a double


% --- Executes during object creation, after setting all properties.
function FootUp2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to FootUp2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function FootUp1_Callback(hObject, eventdata, handles)
% hObject    handle to FootUp1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of FootUp1 as text
%        str2double(get(hObject,'String')) returns contents of FootUp1 as a double


% --- Executes during object creation, after setting all properties.
function FootUp1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to FootUp1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function FootUp0_Callback(hObject, eventdata, handles)
% hObject    handle to FootUp0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of FootUp0 as text
%        str2double(get(hObject,'String')) returns contents of FootUp0 as a double


% --- Executes during object creation, after setting all properties.
function FootUp0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to FootUp0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function FootDown3_Callback(hObject, eventdata, handles)
% hObject    handle to FootDown3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of FootDown3 as text
%        str2double(get(hObject,'String')) returns contents of FootDown3 as a double


% --- Executes during object creation, after setting all properties.
function FootDown3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to FootDown3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function FootDown2_Callback(hObject, eventdata, handles)
% hObject    handle to FootDown2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of FootDown2 as text
%        str2double(get(hObject,'String')) returns contents of FootDown2 as a double


% --- Executes during object creation, after setting all properties.
function FootDown2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to FootDown2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function FootDown1_Callback(hObject, eventdata, handles)
% hObject    handle to FootDown1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of FootDown1 as text
%        str2double(get(hObject,'String')) returns contents of FootDown1 as a double


% --- Executes during object creation, after setting all properties.
function FootDown1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to FootDown1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function FootDown0_Callback(hObject, eventdata, handles)
% hObject    handle to FootDown0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of FootDown0 as text
%        str2double(get(hObject,'String')) returns contents of FootDown0 as a double


% --- Executes during object creation, after setting all properties.
function FootDown0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to FootDown0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function FootDC_Callback(hObject, eventdata, handles)
% hObject    handle to FootDC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit39 as text
%        str2double(get(hObject,'String')) returns contents of edit39 as a double

DC=str2num(get(handles.FootDC,'String'));
if DC>=1
    DC=0;
    set(handles.FootDC,'String','0.00');
end

% Update Return DC
UpdateReturnDC(handles);

% Update handles structure
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function FootDC_CreateFcn(hObject, eventdata, handles)
% hObject    handle to FootDC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function UnloadDC_Callback(hObject, eventdata, handles)
% hObject    handle to UnloadDC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of UnloadDC as text
%        str2double(get(hObject,'String')) returns contents of UnloadDC as a double

DC=str2num(get(handles.UnloadDC,'String'));
if DC>=1
    DC=0;
    set(handles.UnloadDC,'String','0.00');
end

% Update Return DC
UpdateReturnDC(handles);

% Update handles structure
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function UnloadDC_CreateFcn(hObject, eventdata, handles)
% hObject    handle to UnloadDC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function ReturnDC_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ReturnDC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function UpdateReturnDC(handles)

% Calculate how much DC is left for the return stroke.
strokeDC = str2num(get(handles.StrokeDC,'String'));
wingAboveDC = str2num(get(handles.WingAboveDC, 'String'));
wingBelowDC = str2num(get(handles.WingBelowDC, 'String'));
footDC = str2num(get(handles.FootDC, 'String'));
unloadDC = str2num(get(handles.UnloadDC, 'String'));

returnDC = 1 - strokeDC - 2*wingAboveDC - 2*wingBelowDC - footDC - unloadDC;
set(handles.ReturnDC, 'String', num2str(returnDC));
if (returnDC < 0)
    set(handles.ReturnDC, 'BackgroundColor', 'red');
else
    set(handles.ReturnDC, 'BackgroundColor', 'white');
end